"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => reactControlStatements
});
module.exports = __toCommonJS(src_exports);

// src/plugin.ts
function removeJSXComments(code) {
  const commentRegex = /{\/\*[\s\S]*?\*\/}/g;
  return code.replace(commentRegex, "");
}
function transformIf(code) {
  const ifRegex = /<If\s+condition=\{(.+?)}\s*>([\s\S]*?)<\/If>/g;
  return code.replace(ifRegex, (match, condition, content) => {
    return `{${condition} ? (<>${content}</>) : null}`;
  });
}
function transformChoose(code) {
  const chooseRegex = /<Choose>([\s\S]*?)<\/Choose>/g;
  const whenRegex = /<When\s+condition=\{(.+?)}\s*>([\s\S]*?)<\/When>/g;
  const otherwiseRegex = /<Otherwise\s*>([\s\S]*?)<\/Otherwise>/g;
  return code.replace(chooseRegex, (match, chooseContent) => {
    const conditions = [];
    const contents = [];
    let otherwiseContent = null;
    let matchWhen;
    while (matchWhen = whenRegex.exec(chooseContent)) {
      conditions.push(matchWhen[1]);
      contents.push(`(<>${matchWhen[2]}</>)`);
    }
    const conditionsCode = conditions.map((condition, index) => `${condition} ? ${contents[index]}`).join(" : ");
    const matchOtherwise = otherwiseRegex.exec(chooseContent);
    if (matchOtherwise) {
      otherwiseContent = matchOtherwise[1];
    }
    return conditions.length > 0 ? `{${conditionsCode} : ${otherwiseContent ? `<>${otherwiseContent}</>` : "<></>"}}` : `{${otherwiseContent ? `<>${otherwiseContent}</>` : ""}}`;
  });
}
function reactControlStatements() {
  return {
    name: "vite:react-control-statements",
    enforce: "pre",
    transform(_source, id) {
      if (!/\.(tsx|jsx)$/.test(id)) return null;
      let transformedCode = removeJSXComments(_source);
      transformedCode = transformIf(transformedCode);
      transformedCode = transformChoose(transformedCode);
      return {
        code: transformedCode,
        map: null
      };
    }
  };
}
